/*
	SerpEncrypTool - A tool that uses GnuPG in order to manage your passwords and similar things
	Copyright (C) 2004  Michael "Serpedon" Walz

	This file is part of SerpEncrypTool.

	SerpEncrypTool is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	SerpEncrypTool is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with SerpEncrypTool; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

# ifndef __DEFINES_HPP__
# define __DEFINES_HPP__

# include <Klasse.String.hpp>
# include <windows.h>

const String TempFileNotDel				= "Die Tempdatei %s konnte nicht gelscht werden. Diese Datei enthlt ihre Daten in unverschlsselter Form. Sie sollte daher schleunigst gelscht werden.";
const String TempFileNotDelTitel			= "Tempdatei nicht gelscht";
const String ClipboardNotDeleted			= "Empfindliche Daten wurden in die Zwischenablage kopiert. Diese konnte beim Beenden des Dialogs nicht geleert werden. Evtl. enthlt die Zwischenablage diese Daten noch.\nLeeren Sie die Zwischenablage von Hand oder berschreiben Sie ihren Inhalt durch Kopieren eines beliebiges Stck Texts."; 
const String ClipboardNotDeletedTitel	= "Zwischenablage nicht gelscht";
const String SubDialogEntryHideFormat	= "%s (***)";
const String SubDialogEntryFormat		= "%s (%s)";
const String InvalidToken					= "Die Daten sind ungltig. Sie knnen deshalb nicht angezeigt werden. berprfen Sie die Dateien evtl. von Hand und/oder versuchen Sie es erneut.";
const String InvalidTokenTitel			= "Ungltige Daten";
const String ErrorWhileSavingEntries	= "Beim Speichern der Daten trat ein Fehler auf. Evtl. gettigte nderungen werden (leider) nicht gespeichert. Bitte haben Sie mit dem armen Computer Verstndnis...";
const String SavingFailed					= "Speichern fehlgeschlagen";
const String NoEntrySelected				= "Es wurde kein Eintrag ausgewhlt. Diese Funktion erfordert aber einen ausgewhlten Eintrag. Whlen Sie einen Eintrag aus und versuchen Sie es erneut.";
const String NoEntrySelectedTitel		= "Kein Eintrag ausgewhlt";
const String CouldNotSetClipboardData	= "Es konnten keine Daten in die Zwischenablage kopiert werden. Dieser Fehler ist hchst unwahrscheinlich und tritt eigentlich nur auf, wenn ein anderes Programm die Zwischenablage belegt hat und dann abgeschmiert ist.\nVersuchen Sie es einfach erneut und/oder starten Sie den Rechner neu.";
const String ClipboardError				= "Fehler in der Zwischenablage";
const String ReallyDelete					= "Wollen Sie den ausgewhlten Eintrag wirklich entgltig lschen?";
const String RealleyDeleteTitel			= "Eintrag lschen?";
const String InvalidChars					= "Der Eintragsname enthlt ein oder mehrere ungltige Zeichen (* oder =). Entfernen Sie diese Zeichen, um fortzufahren";
const String InvalidCharsTitel			= "Ungltige Zeichen";
const String FileNotDeletedFormat		= "Die Datei %s konnte nicht gelscht werden. Sie enthlt die Daten in verschlsselter Form und stellt deshalb kein groes Sicherheitsrisiko dar. Allerdings vermllt sie die Festplatte, da sie nicht mehr gebraucht wird. Falls Sie sie finden, (ich find' sie nmlich net) knnen Sie sie guten Gewissens lschen.";
const String FileNotDeletedTitel			= "Datei nicht gelscht";
const String FileCouldNotBeCreated		= "Die Datei %s konnte nicht erstellt werden.\nSie haben aber diesen Datensatz mit dieser Datei verknpft. Da deren Erstellung nicht mglich ist, kann auch der Datensatz nicht erstellt werden.\nWir danke fr ihr Verstndnis.";
const String FileNotCreatedTitel			= "Dateierstellung fehlgeschlagen";
const String FileExistAllreadyFormat	= "Die Datei %s existiert bereits. Wollen Sie diese Datei berschreiben lassen? Sie verlieren dadurch alle Informationen, die in der Datei stehen.\n(Ich kann Ihnen aber nicht sagen, ob ich die Datei auch wirklich berschreiben kann. Bei Zweifel wenden Sie sich am Besten an Ihren Systemadministrator.)";
const String FileExistAllready			= "Datei berschreiben?";
const String EncryptionSuccess			= "Verschlsselung erfolgreich";
const String EncryptionFailed				= "Verschlsselung fehlgeschlagen";
const String DecryptionSuccess			= "Entschlsselung erfolgreich";
const String DecryptionFailed				= "Entschlsselung fehlgeschlagen";
const String BadPassphrase					= "Beim Einlesen der Passphrase trat ein unerwarteter Fehler auf.\n(Wahrscheinlich haben Sie ESC gedrckt oder das X-le oben rechts benutzt)";
const String InvalidLength					= "Die Werte drfen nicht leer sein. Sie mssen mindestes einen (1) Buchstaben umfassen.";
const String InvalidLengthTitel			= "Werte zu kurz";
const String WillBeShownAsPlain			= "Sie haben angeben, dass der Wert versteckt werden soll. Wollen Sie ihn wirklich in Klarschrift anzeigen lassen?\n(Damit kann jeder der ihren Bildschirm abguckt, den Wert sehen...)";
const String ShowAsPlain					= "In Reinschrift zeigen?";


const String TempFilePrefix				= "SET";
const String ReplPlain						= "%PLAINTEXT%";
const String ReplGnuPGExe					= "%GPG%";
const String ReplHome						= "%HOME%";
const String ReplComment					= "%COMMENT%";
const String ReplNoVersion					= "--no-version";
const String ReplVerbose					= "--verbose";
const String ReplKeyID						= "%KEYID%";
const String ReplCipherFile				= "%CIPHERFILE%";
const String ReplPlainFile					= "%PLAINTEXTFILE%";
const String StandardIniFile				= ".\\SerpEncrypTool.ini";
const String StdSectionName				= "SerpEncrypTool";

const String EncryptCmdLine	= ReplGnuPGExe + " --homedir \"" + ReplHome + "\" " + ReplVerbose +
	/* <-- */						  " --yes --armor --comment \"" + ReplComment + "\" " +
	/* <-- */						  ReplNoVersion + " --recipient \"" + ReplKeyID + "\""
	/* <-- */						  " --output \"" + ReplCipherFile + 
	/* <-- */						  "\" --encrypt " + ReplPlainFile;
const String DecryptCmdLine	= ReplGnuPGExe + " --homedir \"" + ReplHome + "\" --yes " + ReplVerbose +
	/* <-- */						  " --passphrase-fd 0 --decrypt \"" + ReplCipherFile;
	 
# define OUTPUT_NEVER			0
# define OUTPUT_ON_ERROR		1
# define OUTPUT_ALWAYS			2

# define WM_TIMER_CLOSE			( WM_USER + 1 )

struct s_Global
{
	String keyID;
	String homeDir;
	String comment;
	String mainFilename;
	bool noVersion;
	bool verbose;
	String gpgExe;
	bool disableDoubleClick;
	bool disableEnter;
	char outputType;
	UINT timeout_subDialog;
	UINT timeout_newSubDialog;
};

extern s_Global G_Global;
extern HINSTANCE G_hInstance;

# endif // __DEFINES_HPP__