/*
	SerpEncrypTool - A tool that uses GnuPG in order to manage your passwords and similar things
	Copyright (C) 2004  Michael "Serpedon" Walz

	This file is part of SerpEncrypTool.

	SerpEncrypTool is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	SerpEncrypTool is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with SerpEncrypTool; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

# include <assert.h>
# include "Defines.hpp"
# include "Ressource.h"
# include "Klasse.GetPassphrase.hpp"
# include "WindowFkts.hpp"

c_GetPassphrase::c_GetPassphrase ( ) :
	m_parent ( NULL ), m_hWnd ( NULL ), result ( IDCANCEL )
{
	# if _DEBUG
		m_isInit = false;
		m_wasModal = false;
	# endif
}

c_GetPassphrase::~c_GetPassphrase ( )
{
}


bool c_GetPassphrase::Init ( HWND f_parent )
{
	# if _DEBUG
		assert ( ! m_isInit );
		m_isInit = true;
	# endif
	
	m_parent = f_parent;
	if ( IsWindow ( m_parent ) )
		return true;

	return false;
}

int c_GetPassphrase::DoModal ( )
{
	# if _DEBUG
		assert ( ! m_wasModal );
		assert ( m_isInit );
		m_wasModal = true;
	# endif
	return DialogBoxParam ( G_hInstance,
		/* <-- */				MAKEINTRESOURCE ( IDD_GET_PASSPHRASE ),
		/* <-- */				m_parent,
		/* <-- */				DialogProc,
		/* <-- */				( LPARAM ) this );
}

/* static */ BOOL __stdcall c_GetPassphrase::DialogProc ( 
	/* <-- */				HWND f_hWnd, UINT f_message, WPARAM f_wParam, LPARAM f_lParam )
{
	c_GetPassphrase * pThis =
		/* <-- */ ( c_GetPassphrase * ) GetWindowLong ( f_hWnd, DWL_USER );

	switch ( f_message )
	{
	case WM_INITDIALOG:
		pThis = ( c_GetPassphrase * ) f_lParam;
		SetWindowLong ( f_hWnd, DWL_USER, ( long ) pThis );

		pThis->InitDialog ( f_hWnd );
			
		return true;

	case WM_COMMAND:
		switch ( LOWORD ( f_wParam ) )
		{
		case IDOK:
			pThis->SavePassphrase ( );
		case IDCANCEL:
			SendMessage ( f_hWnd, WM_CLOSE, 0, 0 );
			return true;
		}
		break;

	case WM_CLOSE:
		EndDialog ( f_hWnd, pThis->result );
		return true;
	}

	return false;
}


bool c_GetPassphrase::InitDialog ( HWND f_hWnd )
{
	m_hWnd = f_hWnd;

	// Icon fr das Fenster setzen
	SendMessage ( m_hWnd, WM_SETICON, ICON_BIG,
		/* <-- */	( LPARAM ) LoadIcon ( G_hInstance, MAKEINTRESOURCE ( IDI_ICON ) ) );

	return true;
}


String c_GetPassphrase::GetPassphrase ( )
{
	assert ( m_wasModal );
	return m_passphrase;
}

void c_GetPassphrase::SavePassphrase ( )
{
	result = IDOK;

	m_passphrase = GetEditText ( GetDlgItem ( m_hWnd, IDC_PASSPHRASE ) );
}
