/*
	SerpEncrypTool - A tool that uses GnuPG in order to manage your passwords and similar things
	Copyright (C) 2004  Michael "Serpedon" Walz

	This file is part of SerpEncrypTool.

	SerpEncrypTool is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	SerpEncrypTool is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with SerpEncrypTool; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

# ifndef __KLASSE_NEW_SUB_ENTRY_HPP__
# define __KLASSE_NEW_SUB_ENTRY_HPP__

# include <windows.h>
# include <Klasse.String.hpp>

class c_NewSubEntry
{
public:
	c_NewSubEntry ( );
	~c_NewSubEntry ( );
	bool Init (	HWND f_parent, const String & f_entryName = "",
		/* <-- */	const String & f_value = "", bool f_hideValue = false );
	int DoModal ( );
	String GetEntryName ( );
	String GetValue ( );
	bool GetHideValueFlag ( );
private:
	static BOOL __stdcall DialogProc ( HWND f_hWnd, UINT f_message,
		/* <-- */							  WPARAM f_wParam, LPARAM f_lParam );
	bool InitDialog ( HWND f_hWnd );
# if _DEBUG
	bool m_isInit;
	bool m_wasModal;
# endif

	void SthDid ( );

	bool SaveData ( );
	String m_entryName;
	String m_value;
	bool m_hideValue;

	HWND m_parent;
	HWND m_hWnd;
	int result;
};

# endif // __KLASSE_NEW_SUB_ENTRY_HPP__