/*
	SerpEncrypTool - A tool that uses GnuPG in order to manage your passwords and similar things
	Copyright (C) 2004  Michael "Serpedon" Walz

	This file is part of SerpEncrypTool.

	SerpEncrypTool is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	SerpEncrypTool is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with SerpEncrypTool; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

# include <stdio.h>
# include <DriveFkts.hpp>
# include "Defines.hpp"
# include "Klasse.MainDialog.hpp"
# include "GnuPG.hpp"


s_Global G_Global;
HINSTANCE G_hInstance;


# define GET_INI_STRING( variable, stdValue )															\
	G_Global.##variable = GetIniString ( StdSectionName, #variable, iniFile, stdValue );	\
	WriteIniString ( StdSectionName, #variable, iniFile, G_Global.##variable )

# define GET_INI_INT( variable, stdValue )																\
	G_Global.##variable = GetIniInt ( StdSectionName, #variable, iniFile, stdValue );		\
	WriteIniInt ( StdSectionName, #variable, iniFile, G_Global.##variable )


int WINAPI WinMain ( HINSTANCE f_hInstance, HINSTANCE f_hPrevInstance,
	/* <-- */			LPSTR f_cmdLine, int f_nCmdShow )
{
	G_hInstance = f_hInstance;

	String iniFile; 
	if ( strlen ( f_cmdLine ) )
		iniFile = f_cmdLine;
	else 
		iniFile = StandardIniFile;

	GET_INI_STRING	( keyID, "Michael" );
	GET_INI_STRING	( homeDir, "D:\\profile\\mail\\Zertifikate\\GnuPG" );
	GET_INI_STRING	( comment, "SerpEncrypTool" );
	GET_INI_INT		( noVersion, false );
	GET_INI_STRING	( gpgExe, "C:\\programme\\GnuPG\\gpg.exe" );
	GET_INI_INT		( verbose, false );
	GET_INI_INT		( disableDoubleClick, false );
	GET_INI_INT		( disableEnter, false );
	GET_INI_INT		( outputType, OUTPUT_ON_ERROR );
	GET_INI_STRING	( mainFilename, "SerpEncrypTool.Main.txt" );
	GET_INI_INT		( timeout_subDialog, 15000 );
	GET_INI_INT		( timeout_newSubDialog, 30000 );

	String data;
	if ( ExistFile ( G_Global.mainFilename ) )
	{
		if ( ! DecryptTotal ( G_Global.mainFilename, & data, NULL ) )
			return false;
	}

	c_MainDialog mainDialog;
	mainDialog.Init ( NULL, data );

	mainDialog.DoModal ( );

	String newData = mainDialog.GetNewData ( );

	if ( newData != data )
		EncryptTotal ( newData, G_Global.mainFilename, NULL );

	return true;
}