/*
	SerpEncrypTool - A tool that uses GnuPG in order to manage your passwords and similar things
	Copyright (C) 2004  Michael "Serpedon" Walz

	This file is part of SerpEncrypTool.

	SerpEncrypTool is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	SerpEncrypTool is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with SerpEncrypTool; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

# include "WindowFkts.hpp"

String GetEditText ( HWND f_hEdit )
{
	String result;
	int length = SendMessage ( f_hEdit, WM_GETTEXTLENGTH, 0, 0 );
	// the terminating null character
	length++;
	char * buffer = new char [ length ];
	if ( buffer )
	{
		SendMessage ( f_hEdit, WM_GETTEXT,
			/* <-- */  length, ( LPARAM ) buffer );
		result = buffer;
		delete [ ] buffer;
	}
	return result;
}

int AddListBoxItemAndLink ( HWND f_listBox, const String & f_string, void * fp_link )
{
	int index = SendMessage ( f_listBox, LB_ADDSTRING, 0, ( LPARAM ) ( LPCTSTR ) f_string );

	if ( SendMessage ( f_listBox, LB_SETITEMDATA, index, ( LPARAM ) fp_link ) == LB_ERR )
		return LB_ERR;

	return index;
}
